#include <iostream>

using namespace std;

int main()
{
	string s1 = "moguce";
	string s2 = "nemoguce";
	long long int krv[4];
	long long int n, i, j, t;
	long long int donori[10000][4];
	string grupe[10000];
	long long int potrebno[10000];
	bool ok = true;


	cin >> n;
	cin >> krv[0] >> krv[1] >> krv[2] >> krv[3];

	for (i = 0; i < n; i++)
	{
		cin >> grupe[i] >> potrebno[i];
		donori[i][0] = 0;
		donori[i][1] = 0;
		donori[i][2] = 0;
		donori[i][3] = 0;
	}

	for (i = 0; i < n; i++)
	{
		if (grupe[i] == "AB")
			continue;
		else if (grupe[i] == "O")
		{
			if (krv[0] < potrebno[i])
			{
				ok = false;
				break;
			}
			krv[0] -= potrebno[i];
			donori[i][0] += potrebno[i];
			potrebno[i] = 0;
		}
		else if (grupe[i] == "A")
		{
			t = min(krv[1], potrebno[i]);
			krv[1] -= t;
			potrebno[i] -= t;
			donori[i][1] += t;
			if (!potrebno[i])
				continue;

			if (krv[0] < potrebno[i])
			{
				ok = false;
				break;
			}
			krv[0] -= potrebno[i];
			donori[i][0] += potrebno[i];
			potrebno[i] = 0;
		}
		else if (grupe[i] == "B")
		{
			t = min(krv[2], potrebno[i]);
			krv[2] -= t;
			potrebno[i] -= t;
			donori[i][2] += t;
			if (!potrebno[i])
				continue;

			if (krv[0] < potrebno[i])
			{
				ok = false;
				break;
			}
			krv[0] -= potrebno[i];
			donori[i][0] += potrebno[i];
			potrebno[i] = 0;
		}
	}

	if (ok == false)
	{
		cout << s2;
		return 0;
	}

	for (i = 0; i < n; i++)
	{
		if (grupe[i] != "AB")
			continue;
		else if (grupe[i] == "AB")
		{
			t = min(krv[3], potrebno[i]);
			krv[3] -= t;
			potrebno[i] -= t;
			donori[i][3] += t;
			if (!potrebno[i])
				continue;

			t = min(krv[2], potrebno[i]);
			krv[2] -= t;
			potrebno[i] -= t;
			donori[i][2] += t;
			if (!potrebno[i])
				continue;

			t = min(krv[1], potrebno[i]);
			krv[1] -= t;
			potrebno[i] -= t;
			donori[i][1] += t;
			if (!potrebno[i])
				continue;

			if (krv[0] < potrebno[i])
			{
				ok = false;
				break;
			}
			krv[0] -= potrebno[i];
			donori[i][0] += potrebno[i];
			potrebno[i] = 0;
		}
	}


	if (ok == false)
	{
		cout << s2;
		return 0;
	}

	cout << s1 << endl;
	for (i = 0; i < n; i++)
	{
		for (j = 0; j < 4; j++)
		{
			cout << donori[i][j] << " ";
		}
		cout << endl;
	}

	return 0;
}